<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item prop="name">
                <el-input v-model="queryParams.name" placeholder="请输入衣服名称" clearable @keyup.enter.native="handleQuery" />
            </el-form-item>
            <el-form-item prop="typeId">
                <el-select v-model="queryParams.typeId" placeholder="衣服种类" clearable>
                    <el-option v-for="item in clothTypeList" :label="item.name" :value="item.id" :key="item.name"> </el-option>
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
                <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="el-icon-plus" @click="handleAdd" v-hasPermi="['coupon:type:add']">新增</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <Page uri="/mapi/app/couponTypeApplyCloth/list" :request-params="queryParams" ref="pagination">
            <el-table-column label="编号" align="center" prop="id" />
            <el-table-column label="衣服名称" align="center" prop="clothItemName" />
            <el-table-column label="衣服类型名称" align="center" prop="clothItemTypeName" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="150">
                <template slot-scope="scope">
                    <!--          <el-button-->
                    <!--             -->
                    <!--            type="text"-->
                    <!--            icon="el-icon-edit"-->
                    <!--            @click="handleUpdate(scope.row)"-->
                    <!--            v-hasPermi="['coupon:type:edit']"-->
                    <!--          >修改</el-button>-->
                    <el-button type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['coupon:type:remove']">删除</el-button>
                </template>
            </el-table-column>
        </Page>

        <!-- 添加或修改优惠券可使用衣物对话框 -->
        <el-dialog :title="title" :visible.sync="open" size="30%" append-to-body>
            <el-row :gutter="15">
                <el-form :inline="true" label-width="100px">
                    <el-col :span="24">
                        <el-form-item label="衣服种类">
                            <el-select v-model="typeId" placeholder="衣服种类" clearable @input="getClothList">
                                <el-option v-for="item in clothTypeList" :label="item.name" :value="item.id" :key="item.name"> </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules">
                    <el-col :span="24">
                        <el-form-item required>
                            <el-select v-model="clothItemIdList" multiple placeholder="请选择衣服" clearable>
                                <el-option v-for="item in clothList" :key="item.id" :label="item.name" :value="item.id"> </el-option>
                            </el-select>
                        </el-form-item>
                        <!--s-->
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listCouponTypeApplyCloth, getCouponTypeApplyCloth, delCouponTypeApplyCloth, addCouponTypeApplyCloth, updateCouponTypeApplyCloth, updateCouponTypeApplyClothStatus } from '@/api/coupon/typeApplyCloth'
import { listType } from '@/api/core/clothType'
import { listClothItem } from '@/api/core/clothItem'

export default {
    name: 'CouponTypeApplyCloth',
    data() {
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 优惠券可使用衣物表格数据
            couponTypeApplyClothList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {},
            // 表单参数
            form: {},
            // 表单校验
            rules: {},
            clothTypeList: [],
            clothItemIdList: [],
            clothList: [],
            couponTypeId: null,
            typeId: null
        }
    },
    created() {
        this.couponTypeId = this.$route.params && this.$route.params.couponTypeId
        this.getClothTypeList()
        this.getList()
        listClothItem({ pageSize: 999999, pageNum: 1 }).then((res) => {
            this.clothList = res.rows
        })
    },
    methods: {
        /** 查询优惠券可使用衣物列表 */
        getList() {
            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        /** 获取衣服类型 */
        getClothTypeList() {
            listType({ pageSize: 999999, pageNum: 1 }).then((response) => {
                this.clothTypeList = response.rows
            })
        },
        getClothList() {
            const params = {
                pageSize: 999999,
                pageNum: 1
            }
            if (this.typeId != null) {
                params.typeId = this.typeId
            }
            listClothItem(params).then((res) => {
                this.clothList = res.rows
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                clothItemId: null,
                couponTypeId: null,
                delFlag: null,
                createById: null,
                createBy: null,
                createTime: null,
                updateById: null,
                updateBy: null,
                updateTime: null,
                remark: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加优惠券可使用衣物'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getCouponTypeApplyCloth(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '修改优惠券可使用衣物'
            })
        },
        /** 提交按钮 */
        submitForm() {
            if (this.clothItemIdList == null || this.clothItemIdList.length == 0) {
                this.$message.error('衣服不能为空')
                return
            }
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    this.form.couponTypeId = this.couponTypeId
                    this.form.clothItemIdList = this.clothItemIdList
                    if (this.form.id != null) {
                        updateCouponTypeApplyCloth(this.form).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        addCouponTypeApplyCloth(this.form).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除可使用衣物编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delCouponTypeApplyCloth(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/app/couponTypeApplyCloth/export',
                {
                    ...this.queryParams
                },
                `couponTypeApplyCloth_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        }
    }
}
</script>
